<!-- eslint-disable vue/no-mutating-props -->
<script setup lang="ts">
import type { Answers } from '@/types/Answers';
import type { Answer } from '@/types/Answer';
import AnswerButtons from './AnswerButtons.vue';
import SdgButton from './SdgButton.vue';

import { useGameStore } from '../stores/gameStore';
import { ref, computed } from 'vue';

const props = defineProps<{
  answers?: Answers;
}>();

const awarded = ref<boolean>(false);
const awardedText = computed(() => (awarded.value ? ' +1' : ''));

const emit = defineEmits(['onCorrectAnswerClick', 'onNextClick']);

async function onAnswerClick(answer: Answer): Promise<void> {
  if (props.answers) {
    if (answer.isCorrectAnswer) {
      answer.hasBeenPicked = true;
      if (props.answers.answers.length > 1 && !props.answers.pickedIncorrectAnswer) {
        const gameStore = useGameStore();
        await gameStore.addOnePoint();
        awarded.value = true;
      }
      props.answers.answers.forEach((x) => (x.hasBeenPicked = true));
      props.answers.pickedCorrectAnswer = true;
      emit('onCorrectAnswerClick', props.answers);
    } else {
      answer.hasBeenPicked = true;
      props.answers.pickedIncorrectAnswer = true;
    }
  }
}

function onNext() {
  emit('onNextClick');
}
</script>
<template>
  <div class="text-xl text-center text-green-900" v-if="props.answers?.pickedCorrectAnswer">
    Correct!<span class="text-red-600">{{ awardedText }}</span>
  </div>
  <div class="text-xl text-center text-red-900" v-else-if="props.answers?.pickedIncorrectAnswer">Nope! -- Try Again!</div>
  <AnswerButtons v-if="props.answers" :answers="props.answers" @onAnswerClick="onAnswerClick" />
  <div class="text-center">
    <SdgButton v-if="!props.answers || props.answers.pickedCorrectAnswer" class="text-center" color="bg-sdg-blue" @onClick="onNext">
      <span class="text-black">Next</span>
    </SdgButton>
  </div>
</template>
